import type { ClickMode } from "../Enums/Modes/ClickMode";
import type { Container } from "./Container";
import type { Engine } from "../engine";
import type { ICoordinates } from "./Interfaces/ICoordinates";
import type { IDelta } from "./Interfaces/IDelta";
import type { IMouseData } from "./Interfaces/IMouseData";
import type { IParticle } from "./Interfaces/IParticle";
import type { IParticlesOptions } from "../Options/Interfaces/Particles/IParticlesOptions";
import { Particle } from "./Particle";
import { QuadTree } from "./Utils/QuadTree";
import type { RecursivePartial } from "../Types/RecursivePartial";
export declare class Particles {
    #private;
    private readonly container;
    array: Particle[];
    lastZIndex: number;
    limit: number;
    movers: import("./Interfaces/IParticleMover").IParticleMover[];
    needsSort: boolean;
    pushing?: boolean;
    quadTree: QuadTree;
    updaters: import("..").IParticleUpdater[];
    zArray: Particle[];
    private readonly freqs;
    private readonly interactionManager;
    private nextId;
    constructor(engine: Engine, container: Container);
    get count(): number;
    addManualParticles(): void;
    addParticle(position?: ICoordinates, overrideOptions?: RecursivePartial<IParticlesOptions>, group?: string): Particle | undefined;
    addSplitParticle(parent: Particle, splitParticlesOptions?: RecursivePartial<IParticlesOptions>): Particle | undefined;
    clear(): void;
    destroy(): void;
    draw(delta: IDelta): Promise<void>;
    getLinkFrequency(p1: IParticle, p2: IParticle): number;
    getTriangleFrequency(p1: IParticle, p2: IParticle, p3: IParticle): number;
    handleClickMode(mode: ClickMode | string): void;
    init(): void;
    push(nb: number, mouse?: IMouseData, overrideOptions?: RecursivePartial<IParticlesOptions>, group?: string): void;
    redraw(): Promise<void>;
    remove(particle: Particle, group?: string, override?: boolean): void;
    removeAt(index: number, quantity?: number, group?: string, override?: boolean): void;
    removeQuantity(quantity: number, group?: string): void;
    setDensity(): void;
    update(delta: IDelta): Promise<void>;
    private applyDensity;
    private initDensityFactor;
    private pushParticle;
}
