import type { Container } from "../Container";
import type { ICoordinates } from "../Interfaces/ICoordinates";
import type { IDimension } from "../Interfaces/IDimension";
import type { Particle } from "../Particle";
import type { Point } from "./Point";
import type { Range } from "./Range";
import { Rectangle } from "./Rectangle";
export declare class QuadTree {
    readonly rectangle: Rectangle;
    readonly capacity: number;
    readonly points: Point[];
    private divided;
    private northEast?;
    private northWest?;
    private southEast?;
    private southWest?;
    constructor(rectangle: Rectangle, capacity: number);
    insert(point: Point): boolean;
    query(range: Range, check?: (particle: Particle) => boolean, found?: Particle[]): Particle[];
    queryCircle(position: ICoordinates, radius: number, check?: (particle: Particle) => boolean): Particle[];
    queryCircleWarp(position: ICoordinates, radius: number, containerOrSize: Container | IDimension, check?: (particle: Particle) => boolean): Particle[];
    queryRectangle(position: ICoordinates, size: IDimension, check?: (particle: Particle) => boolean): Particle[];
    private subdivide;
}
