import type { ICoordinates } from "../Interfaces/ICoordinates";
export declare class Vector implements ICoordinates {
    x: number;
    y: number;
    protected constructor(xOrCoords: number | ICoordinates, y?: number);
    static get origin(): Vector;
    get angle(): number;
    set angle(angle: number);
    get length(): number;
    set length(length: number);
    static clone(source: Vector): Vector;
    static create(x: number | ICoordinates, y?: number): Vector;
    add(v: Vector): Vector;
    addTo(v: Vector): void;
    copy(): Vector;
    distanceTo(v: Vector): number;
    distanceToSq(v: Vector): number;
    div(n: number): Vector;
    divTo(n: number): void;
    getLengthSq(): number;
    manhattanDistanceTo(v: Vector): number;
    mult(n: number): Vector;
    multTo(n: number): void;
    rotate(angle: number): Vector;
    setTo(v: ICoordinates): void;
    sub(v: Vector): Vector;
    subFrom(v: Vector): void;
    private updateFromAngle;
}
